function Decoder(bytes, port) {
  var decoded = {};
  var events = {
    1: 'test',
    2: 'air',
    3: 'gps'
  };
  decoded.event = events[port];
  if (port == 2) {
    decoded.seqno = ((bytes[0] << 8) + bytes[1]);
    if (bytes[2] & 0x80)
      decoded.temperature = ((0xffff << 16) + (bytes[2] << 8) + bytes[3]) / 10.0;
    else
      decoded.temperature = ((bytes[2] << 8) + bytes[3]) / 10.0;
    decoded.humidity = ((bytes[4] << 8) + bytes[5]) / 10.0;
  } else if (port == 2 || port == 3) {
    decoded.seqno = ((bytes[0] << 8) + bytes[1]);
    decoded.temperature = ((bytes[2] << 8) + bytes[3]) / 10.0;
    decoded.humidity = ((bytes[4] << 8) + bytes[5]) / 10.0;
    hdop = ((bytes[6] << 8) + bytes[7]) / 100.0;
    if (hdop != 0) {
      decoded.hdop = hdop;
      decoded.latitude = ((bytes[8] << 24) + (bytes[9] << 16) + (bytes[10] << 8) + bytes[11]) / 1000000;
      decoded.longitude = ((bytes[12] << 24) + (bytes[13] << 16) + (bytes[14] << 8) + bytes[15]) / 1000000;
      decoded.altitude = ((bytes[16] << 8) + bytes[17]);
    }
  }
  return decoded;
}